| Version: 3.3.1

Public Member Functions | Static Public Member Functions | List of all members
wxDisplay Class Reference
Class List by Category » Application and System configuration

`#include <wx/display.h>`

## Detailed Description

Determines the sizes and locations of displays connected to the system.

##

Library: wxCore
Category: Application and System configuration

## Public Member Functions
| wxDisplay ()
| Default constructor creating wxDisplay object representing the primary display. More...
| wxDisplay (unsigned int index)
| Constructor, setting up a wxDisplay instance with the specified display. More...
| wxDisplay (const wxWindow *window)
| Constructor creating the display object associated with the given window. More...
| ~wxDisplay ()
| Destructor. More...
bool | ChangeMode (const wxVideoMode &mode=wxDefaultVideoMode)
| Changes the video mode of this display to the mode specified in the mode parameter. More...
wxRect | GetClientArea () const
| Returns the client area of the display. More...
wxVideoMode | GetCurrentMode () const
| Returns the current video mode that this display is in. More...
wxRect | GetGeometry () const
| Returns the bounding rectangle of the display whose index was passed to the constructor. More...
wxArrayVideoModes | GetModes (const wxVideoMode &mode=wxDefaultVideoMode) const
| Fills and returns an array with all the video modes that are supported by this display, or video modes that are supported by this display and match the mode parameter (if mode is not wxDefaultVideoMode). More...
wxString | GetName () const
| Returns the display's name. More...
int | GetDepth () const
| Returns display depth, i.e. More...
wxSize | GetPPI () const
| Returns display resolution in pixels per inch. More...
double | GetScaleFactor () const
| Returns scaling factor used by this display. More...
bool | IsConnected () const
| Returns true if the display has not been unplugged yet. More...
bool | IsPrimary () const
| Returns true if the display is the primary display. More...

## Static Public Member Functions
static unsigned int | GetCount ()
| Returns the number of connected displays. More...
static int | GetFromPoint (const wxPoint &pt)
| Returns the index of the display on which the given point lies, or `wxNOT_FOUND` if the point is not on any connected display. More...
static int | GetFromRect (const wxRect &rect)
| Returns the index of the display with biggest intersection with the given rectangle or `wxNOT_FOUND` if the rectangle doesn't intersect any display. More...
static int | GetFromWindow (const wxWindow *win)
| Returns the index of the display on which the given window lies. More...
static int | GetStdPPIValue ()
| Returns default display resolution for the current platform in pixels per inch. More...
static wxSize | GetStdPPI ()
| Returns default display resolution for the current platform as wxSize. More...

## Constructor & Destructor Documentation

## ◆ wxDisplay() [1/3]

wxDisplay::wxDisplay | ( |  | ) |

Default constructor creating wxDisplay object representing the primary display.

## ◆ wxDisplay() [2/3]

wxDisplay::wxDisplay | ( | unsigned int | index | ) |
| explicit

Constructor, setting up a wxDisplay instance with the specified display.

Parameters

  index | The index of the display to use. This must be non-negative and lower than the value returned by GetCount().

## ◆ wxDisplay() [3/3]

wxDisplay::wxDisplay | ( | const wxWindow * | window | ) |
| explicit

Constructor creating the display object associated with the given window.

This is the most convenient way of finding the display on which the given window is shown while falling back to the default display if it is not shown at all or positioned outside of any display.

Parameters

  window | A valid, i.e. non-null, window.

See also
  GetFromWindow()

Since
  3.1.2

## ◆ ~wxDisplay()

wxDisplay::~wxDisplay | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ ChangeMode()

bool wxDisplay::ChangeMode | ( | const wxVideoMode & | mode = `wxDefaultVideoMode` | ) |

Changes the video mode of this display to the mode specified in the mode parameter.

If wxDefaultVideoMode is passed in as the mode parameter, the defined behaviour is that wxDisplay will reset the video mode to the default mode used by the display. On Windows, the behaviour is normal. However, there are differences on other platforms. On Unix variations using X11 extensions it should behave as defined, but some irregularities may occur.

## ◆ GetClientArea()

wxRect wxDisplay::GetClientArea | ( |  | ) | const

Returns the client area of the display.

The client area is the part of the display available for the normal (non full screen) windows, usually it is the same as GetGeometry() but it could be less if there is a taskbar (or equivalent) on this display.

## ◆ GetCount()

static unsigned int wxDisplay::GetCount | ( |  | ) |
| static

Returns the number of connected displays.

## ◆ GetCurrentMode()

wxVideoMode wxDisplay::GetCurrentMode | ( |  | ) | const

Returns the current video mode that this display is in.

## ◆ GetDepth()

int wxDisplay::GetDepth | ( |  | ) | const

Returns display depth, i.e.

number of bits per pixel (0 if unknown)

Since
  3.1.2

## ◆ GetFromPoint()

static int wxDisplay::GetFromPoint | ( | const wxPoint & | pt | ) |
| static

Returns the index of the display on which the given point lies, or `wxNOT_FOUND` if the point is not on any connected display.

Parameters

  pt | The point to locate.

## ◆ GetFromRect()

static int wxDisplay::GetFromRect | ( | const wxRect & | rect | ) |
| static

Returns the index of the display with biggest intersection with the given rectangle or `wxNOT_FOUND` if the rectangle doesn't intersect any display.

Note that usually the returned display will be the same display which contains the center of the rectangle, but this is not always the case, as rectangle might be partly visible even if its center is off screen, and in this case GetFromPoint() would returns `wxNOT_FOUND`, but this function would return a valid display.

Parameters

  rect | The rectangle to check.

Since
  3.3.0

## ◆ GetFromWindow()

static int wxDisplay::GetFromWindow | ( | const wxWindow * | win | ) |
| static

Returns the index of the display on which the given window lies.

If the window is on more than one display it gets the display that overlaps the window the most.

Returns `wxNOT_FOUND` if the window is not on any connected display.

Parameters

  win | The window to locate.

## ◆ GetGeometry()

wxRect wxDisplay::GetGeometry | ( |  | ) | const

Returns the bounding rectangle of the display whose index was passed to the constructor.

See also
  GetClientArea(), wxDisplaySize()

## ◆ GetModes()

wxArrayVideoModes wxDisplay::GetModes | ( | const wxVideoMode & | mode = `wxDefaultVideoMode` | ) | const

Fills and returns an array with all the video modes that are supported by this display, or video modes that are supported by this display and match the mode parameter (if mode is not wxDefaultVideoMode).

## ◆ GetName()

wxString wxDisplay::GetName | ( |  | ) | const

Returns the display's name.

The returned value is currently an empty string under all platforms except MSW.

## ◆ GetPPI()

wxSize wxDisplay::GetPPI | ( |  | ) | const

Returns display resolution in pixels per inch.

Horizontal and vertical resolution are returned in `x` and `y` components of the wxSize object respectively.

If the resolution information is not available, returns `wxSize(0, 0)`.

Since
  3.1.2

## ◆ GetScaleFactor()

double wxDisplay::GetScaleFactor | ( |  | ) | const

Returns scaling factor used by this display.

The scaling factor is the ratio between GetPPI() and GetStdPPI() (it is implicitly assumed that this ratio is the same for both horizontal and vertical components).

See also
  wxWindow::GetContentScaleFactor(), wxWindow::GetDPIScaleFactor()

Since
  3.1.5

## ◆ GetStdPPI()

static wxSize wxDisplay::GetStdPPI | ( |  | ) |
| static

Returns default display resolution for the current platform as wxSize.

This function is equivalent to constructing wxSize object with both components set to GetStdPPIValue().

Since
  3.1.5

## ◆ GetStdPPIValue()

static int wxDisplay::GetStdPPIValue | ( |  | ) |
| static

Returns default display resolution for the current platform in pixels per inch.

This function mostly used internally, use GetPPI() to get the actual display resolution.

Currently the standard PPI is the same in both horizontal and vertical directions on all platforms and its value is 96 everywhere except under Apple devices (those running macOS, iOS, watchOS etc), where it is 72.

See also
  GetStdPPI()

Since
  3.1.5

## ◆ IsConnected()

bool wxDisplay::IsConnected | ( |  | ) | const

Returns true if the display has not been unplugged yet.

This function can return false if the display configuration has changed since this wxDisplay object has been created and either this display is known not to be connected to the system any more (support for detecting this is currently only implemented in wxMSW) or the display status is now unknown (which happens in all the other ports detecting the display configuration changes, e.g. wxOSX).

A disconnected object is still usable, but all accessor functions return invalid fallback values (e.g. 0 for the width and height) and so such objects are not really useful any more. It is recommended to recreate them when the display configuration changes, which can be done in wxEVT_DISPLAY_CHANGED handler of any top-level window.

Since
  3.3.0

## ◆ IsPrimary()

bool wxDisplay::IsPrimary | ( |  | ) | const

Returns true if the display is the primary display.

The primary display is the one whose index is 0.